<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class provides Reseller Account management
 *
 * @package    OSB
 * @category   Controllers/Reseller
 * @author     Deon George
 * @copyright  (c) 2009-2013 Open Source Billing
 * @license    http://dev.osbill.net/license.html
 */
class Controller_Reseller_Account extends Controller_Account {
	protected $secure_actions = array(
		'ajaxlist'=>TRUE,
		'list'=>TRUE,
		'listlog'=>TRUE,
	);

	/**
	 * Used by AJAX calls to find accounts
	 * @note list_autocomplete() will limit to authorised accounts
	 */
	public function action_ajaxlist() {
		$result = array();

		if (isset($_REQUEST['term']) AND trim($_REQUEST['term']))
			$result += ORM::factory('Account')->list_autocomplete($_REQUEST['term']);

		$this->auto_render = FALSE;
		$this->response->headers('Content-Type','application/json');
		$this->response->body(json_encode(array_values($result)));
	}

	/**
	 * Show a list of accounts
	 */
	public function action_list() {
		Block::add(array(
			'title'=>_('Customer List'),
			'body'=>Table::display(
				$this->filter(ORM::factory('Account')->list_active(),$this->ao->RTM->customers($this->ao->RTM),'sortkey(TRUE)','id'),
				25,
				array(
					'id'=>array('label'=>'ID','url'=>URL::link('reseller','invoice/list/')),
					'accnum()'=>array('label'=>'Num'),
					'name(TRUE)'=>array('label'=>'Account'),
					'email'=>array('label'=>'Email'),
					'invoices_due_total(NULL,TRUE)'=>array('label'=>'Invoices','class'=>'right'),
					'services_count(TRUE)'=>array('label'=>'Services','class'=>'right'),
				),
				array(
					'page'=>TRUE,
					'type'=>'select',
					'form'=>URL::link('reseller','invoice/list'),
				)),
		));
	}

	/**
	 * Show a list of account logins
	 */
	public function action_listlog() {
		Block::add(array(
			'title'=>_('Account Login Log'),
			'body'=>Table::display(
				$this->filter(ORM::factory('Account_Log')->find_all(),$this->ao->RTM->customers($this->ao->RTM),NULL,'account_id'),
				25,
				array( 
					'id'=>array('label'=>'ID'),
					'date_orig'=>array('label'=>'Date'),
					'account->name()'=>array('label'=>'Account'),
					'ip'=>array('label'=>'IP Address'),
					'details'=>array('label'=>'Details'),
				),
				array( 
					'page'=>TRUE,
				)),
			));
	}
}
?>
